
//Autor:            
   
//***********************************************************************************/
#define SCK_H   P2OUT |= BIT2;    //P2.2 SCK gelb
#define SCK_L   P2OUT &=~BIT2;
#define DATA_H  P3OUT |= BIT0;    //P3.0 DATA grn
#define DATA_L  P3OUT &=~BIT0;


#define SHT11_TEMP	0x03    //Befehl Temperatur auslesen
#define SHT11_FEUCHT	0x05  //Befehl Feuchte auslesen
#define SHT11_WSTAT	0x06
#define SHT11_RSTAT	0x07
#define SHT11_RESET	0x1E


char schreiben_byte(unsigned char value);
void s_zuruecksetzen(void);
//char lesen_byte(unsigned char ack);
char lesen_byte(void);
//unsigned int  Tempwert1,Messwert1,Messwert2,Messwert3;
void s_transstart(void);
void pause5(void);
void pause_50(void);
void feuchte_lesen(void);
void pause_50000(void);		//ca.200ms
void pause_40000(void);			
void feuchte_SHT11(void);
unsigned char value,pruefsumme,LSB,MSB;


//----------------------------------------------------------------------------------
char schreiben_byte(unsigned char value)
//----------------------------------------------------------------------------------
// writes a byte on the Sensibus and checks the acknowledge 
{ 
  unsigned char i,error=0; 
  P3DIR |= BIT0;
  for (i=0x80;i>0;i/=2)             //shift bit for masking
  { if (i & value) DATA_H          //masking value with i , write to SENSI-BUS
   else
   DATA_L;
   SCK_H; 												//clk for SENSI-BUS
   SCK_L;
  }

  SCK_H;                            //clk #9 for ack 
  P3DIR &=~BIT0;
  error=P3IN&BIT0;                  //check ack (DATA will be pulled down by SHT11)
  SCK_L;;
      
  return error;                     //error=1 in case of no acknowledge
}
void s_zuruecksetzen(void)
//----------------------------------------------------------------------------------
// communication reset: DATA-line=1 and at least 9 SCK cycles followed by transstart
//       _____________________________________________________         ________
// DATA:                                                      |_______|
//          _    _    _    _    _    _    _    _    _        ___     ___
// SCK : __| |__| |__| |__| |__| |__| |__| |__| |__| |______|   |___|   |______
{  
  unsigned char i; 
  DATA_H; SCK_L;                    //Initial state
  for(i=0;i<9;i++)                  //9 SCK cycles
  { SCK_H;
    SCK_L;
  }
  s_transstart();                   //transmission start
}
void feuchte_SHT11(void)
{
	 s_zuruecksetzen();
   schreiben_byte(SHT11_FEUCHT);
	 pause_50000();                 //80ms fr 12 Bit, 320ms fr 14Bit
	 feuchte_lesen();
}

void s_transstart(void)
//----------------------------------------------------------------------------------
// generates a transmission start 
//       _____         ________
// DATA:      |_______|
//           ___     ___
// SCK : ___|   |___|   |______

{ P2DIR |= BIT2;                   // Set P2.2 to output direction
  P3DIR |= BIT0;
  DATA_H; SCK_L;                   //Initial state
   SCK_H;
   DATA_L;
   SCK_L;  
   SCK_H;
   DATA_H;		   
   SCK_L;		   
}

void feuchte_lesen(void)
{
  unsigned char i,val=0,val2=0,val3=0;
  P3DIR |=BIT0;
  DATA_H;                           //release DATA-line
  P3DIR &=~BIT0;
  for (i=0x80;i>0;i/=2)             //shift bit for masking   1.Byte MSB
  { SCK_H;                          //clk for SENSI-BUS
    if (P3IN&BIT0)val=(val | i);    //read bit  
    SCK_L;  					 
  }
  SCK_H;                            //clk #9 for ack
  SCK_L;	                          
 
  // DATA_H;                         //release DATA-line
 MSB =val;
  
   for (i=0x80;i>0;i/=2)             //shift bit for masking  2.Byte MSB
  {
  	SCK_H;                           //clk for SENSI-BUS
    if (P3IN&BIT0)(val2)=((val2) | i);   //read bit  
    SCK_L;  					 
  }
 
 SCK_H;                             //clk #9 for ack
 SCK_L;						    
 //DATA_H;                          //release DATA-line
 LSB=(val2);
 
 for (i=0x80;i>0;i/=2)              //shift bit for masking
  { SCK_H;                          //clk for SENSI-BUS
    if (P3IN&BIT0)val3=(val3 | i);  //read bit  
    SCK_L;  					 
  }
 
 SCK_H;                             //clk #9 for ack
 SCK_L;						    
  //DATA_H;                         //release DATA-line
 pruefsumme=val3;


 lcd_write_command(LCD_CMD_CURSOR_LA,78);    //26 Zeilenanfang 2.Zeile --> 26 Zeichen pro Zeile
 lcd_write_command(LCD_CMD_CURSOR_HA,0);
		
	  char txt1[5],z,c;
    sprintf(txt1,"%05u", MSB);
    for (z=0; z<5;z++)
    {
    c=txt1[z];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);
     
  }
  lcd_write_command(LCD_CMD_WRITE_DATA, ' ');  
  
    char txt2[5],k;
    sprintf(txt2,"%05u", LSB);
    for (k=0; k<5;k++)
    {
    c=txt2[k];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);
  }
  lcd_write_command(LCD_CMD_WRITE_DATA, ' ');  
  
    char txt3[5];
    sprintf(txt3,"%05u", pruefsumme);
    for (k=0; k<5;k++)
    {
    c=txt3[k];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);
  }
}

void pause5(void)
{ char i;
  for (i=5;i>0;i--);
}
void pause_50(void)
{  unsigned int i;
  for (i=50;i>0;i--);
}
void pause_50000(void)			//ca.200ms
{  unsigned int i;
  for (i=50000;i>0;i--);
}

void pause_40000(void)			//ca.200ms
{  unsigned int i;
  for (i=40000;i>0;i--);
}
